from thespian.actors import *
# import runS1S2
import datetime
import os
import re
from subprocess import Popen, PIPE
import subprocess
import numpy as np
from carputils import tools




class output_actor(Actor):
    def receiveMessage(self, msg, sender):
        S2_interval = msg[1]
        print(msg[0])
        # subprocess.run(msg[0])
        file = msg[0][-1]

        lines = np.loadtxt(file)
        desired_interval = lines[S2_interval:]
        self.send(sender, bool(np.any(desired_interval > 0)))

class simulation_actor(Actor):
    def receiveMessage(self, msg, sender):
        runS1S2.run(msg)
        self.send(sender, "Done")



class Simulation_Manager(Actor):
    def __init__(self):
        # ===========================================
        # Define the initial parameters for the S1S2 protocol
        # ===========================================
        self.S1_strength = 155.0 # Usually the S1 threshold (for this problem, we will pretend 155 is the S1 threshold)
        self.t_final = 300 # duration of the experiment
        self.S2_min = 150000  # Should be set to at least the S1 threshold. (150,000 is closer to the currently set S1-S2 intervals)
        self.S2_absolute_max = 151000 # If unsure, set to maximum possible strength before solution blows up (for this problem, =225,000)
        self.S2_max = self.S2_absolute_max # We want to retain the value of S2_absolute_max, so copy to S2_max to start with
        self.tol = 1 # Find threshold up to a certain tolerance (typically 1 for these experiments).
        self.S1S2_interval_min = 200 # User sets the range of desired S1-S2 time intervals
        self.S1S2_interval_max = 220
        self.S1S2_interval_increment = 5
        self.S1S2_interval = self.S1S2_interval_max # S1S2 interval is set to max to start with
        
        self.nodes = 0 # Number of nodes in the mesh
        self.actor_responses = []

    def receiveMessage(self, message, sender):
    
        # Spawn and actor to run the simulation
        if isinstance(message, str):
            if(str == "start"):
                actor_1 = self.createActor(simulation_actor)
                actor_2 = self.createActor(simulation_actor)
                args = ["--S1-strength", str(self.S1_strength), "--S2-strength", str(self.S2_min - 1), \
                        "--S2-start", str(self.S1S2_interval), "--duration", str(self.t_final)]
                args2 = ["--S1-strength", str(self.S1_strength), "--S2-strength", str(self.S2_max), \
                        "--S2-start", str(self.S1S2_interval), "--duration", str(self.t_final)]

                # self.send(actor_1, args)
                # self.send(actor_2, args2)
            else:
                print("done")


            # check if output directory exists

            # output_folder = str(datetime.date.today().isoformat()) + "_basic_" + str(self.S1_strength)
            # if not os.path.exists(output_folder):
            #     Exception("Output folder does not exist")
            # else:
            #     # Find out how many nodes are in the mesh
            #     # TODO: This is a hacky way to do this. Should be a better way to do this.
            #     output_file = output_folder + "/vm.igb"
            #     process = Popen(["/opt/openCARP/_build/bin/igbhead", output_file], stdout=PIPE)
            #     (output, err) = process.communicate()
            #     exit_code = process.wait()
            #     string_output = output.decode("utf-8").split("\n")
            #     nodes = re.findall(r"\d+", string_output[0])
            #     nodes = int(nodes[0])
            #     self.nodes = nodes

            # # Inspect the mesh
            
            # # Make a temporary directory to store the output values
            # temp_dir = output_folder + "/temp"
            # if not os.path.exists(temp_dir):
            #     os.makedirs(temp_dir)
            # else:
            #     Exception("Temporary directory already exists")

            
            # for i in range(0, self.nodes):
            #     data_file = temp_dir + "/out_" + str(i) + ".txt"
            #     cmd = (["/opt/openCARP/_build/bin/igbextract", "-o", "ascii", "-l", str(i), output_file, "-O", data_file], self.S1S2_interval)
            #     actor = self.createActor(output_actor)
            #     self.send(actor, cmd)
        
        elif isinstance(message, bool):
            self.actor_responses.append(message)
            if len(self.actor_responses) == self.nodes:
                if not all(self.actor_responses):
                    print("APs not generated")





def actor_system_start():
    print("Starting actor system")
    asys = ActorSystem()
    first = asys.createActor(Simulation_Manager)
    # asys.tell(first, "start")

if __name__ == '__main__':
    actor_system_start()
    # print("Starting actor system")
